<%@ page contentType="text/javascript" %>
<%@ taglib prefix="formfactory" uri="http://www.jahia.org/formfactory/functions" %>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>

(function() {
    var mfffPrefill = function(ffTemplateResolver) {
        return {
            restrict: 'E',
            templateUrl: function(el, attrs) {
                return ffTemplateResolver.resolveTemplatePath('${formfactory:addFormFactoryModulePath('/form-factory-prefills/mfff-prefill', renderContext)}', attrs.viewType);
            },
            controller: MfffPrefillController,
            controllerAs: 'mfpc',
            bindToController: true,
            link:linkFunc
        };

        function linkFunc(scope, el, attr, ctrl) {}
    };

    angular.module('formFactory')
            .directive('mfffPrefill', ['ffTemplateResolver', mfffPrefill]);

    var MfffPrefillController = function($FBFS, $FBSP, $http, contextualData, mfffPrefillService, i18n, NCS, $FBPS) {
        var mfpc = this;
        mfpc.prefillName = 'mfff-prefill';
        mfpc.keyMessage = i18n.message("angular.ffPrefillSelectionDirective.label.selectPrefillKey");

        mfpc.$onInit = function() {
            mfpc.input = $FBFS.activeInput;
            if (mfpc.input.prefills[mfpc.prefillName].hideAfterPrefill) {
                var v1 = mfpc.input.prefills[mfpc.prefillName].hideAfterPrefill;
                mfpc.input.prefills[mfpc.prefillName].hideAfterPrefill = !(v1 === "false");
            }

            if (mfpc.input.prefills[mfpc.prefillName].makeReadOnlyAfterPrefill) {
                var v2 = mfpc.input.prefills[mfpc.prefillName].makeReadOnlyAfterPrefill;
                mfpc.input.prefills[mfpc.prefillName].makeReadOnlyAfterPrefill = !(v2 === "false");
            }

            var key = mfpc.input.prefills[mfpc.prefillName].dataKey;

            //Since we store object as string we need to make it an object again
            if (key != undefined && key !== null && key !== '' && key.constructor !== Object) {
                mfpc.input.prefills[mfpc.prefillName].dataKey = JSON.parse(key);
            }

            $http({
                url: contextualData.context + mfffPrefillService.getProxyServletUrl() + "/cxs/profiles/properties/targets/profiles",
                method: "GET"
            }).then(function(data) {
                updateAvailableKeys(data.data);
            }, function(error) {
                console.log(error);
            });
        };

        //This is requried for validation of the prefill.
        mfpc.updateChange = function() {
            if (mfpc.input.prefills[mfpc.prefillName].active) {
                $FBSP.updatePanelValidation(mfpc.prefillName + 'Validation', !_.isEmpty(mfpc.input.prefills[mfpc.prefillName].dataKey));
            }
        };

        mfpc.sync = function(e) {
            var dataKeyObj = mfpc.input.prefills[mfpc.prefillName].dataKey;
            if (!dataKeyObj) {
                return;
            }
            mfpc.input.placeholder = dataKeyObj.metadata.name;
            mfpc.input.label = dataKeyObj.metadata.name;
            mfpc.input.name = dataKeyObj.metadata.id;
            var hasDuplicateName = NCS.hasDuplicateName();
            $FBSP.updatePanelValidation('containsDuplicateInput', !hasDuplicateName);

            var inputDiv = $(e.currentTarget.parentNode.parentNode.parentNode).find(".mfffSelectHolder");
            if (!hasDuplicateName) {
                inputDiv.removeClass('has-error');
                inputDiv.find('.help-block').addClass('hide');
            }
            else {
                inputDiv.addClass('has-error');
                inputDiv.find('.help-block').removeClass('hide');
            }
        };

        function updateAvailableKeys(data) {
            //We make sure that property can be mapped to and that property and input are compatible
            var arr = [];
            var typeObject = mfffPrefillService.getTypeMap()[mfpc.input.nodeType];
            if (typeObject !== undefined && typeObject.type !== null) {
                for (var i in data) {
                    var obj = data[i];
                    var tags = obj.metadata.systemTags;
                    if (tags.indexOf("systemProfileProperties") == -1 && tags.indexOf("hiddenFromFormMappingProperties") == -1 && typeObject.type.indexOf(obj.type) !== -1 && resolve(obj)) {
                        arr.push(obj);
                    }
                }
            }
            else if (typeObject === undefined) { //No input type map defined show all available properties
                arr = data;
            }

            mfpc.input.prefills[mfpc.prefillName].availableDataKeys = arr;
            if (arr.length < 1) {
                mfpc.keyMessage = i18n.message("angular.mfffPrefill.message.noProperties");
            }

            function resolve(obj) {
                var m = obj.multivalued === null ? false : obj.multivalued;
                var m2 = typeObject.valueType === "multiple";

                if (m && m2) {
                    return true;
                }

                if (m && !m2) {
                    return false;
                }

                if (!m && !m2) {
                    return true;
                }

                return false;

            }
        }
    };

    MfffPrefillController.$inject = ['$FBFormStateService', '$FBSidePanelService', '$http', 'contextualData', 'mfffPrefillService', 'i18nService', 'ffNameCheckService', '$FBSidePanelService'];

})();