<%@ page contentType="text/javascript" %>
    /**
     * Each rule will received, the rule definition, its scope.
     * scope.form will contain the form to enable watch and access to other fields in the same step
     * ctrls will be an array of controllers, first the ffFormController and then the ngModel of the associated input.
     *
     * @param {object} rule current rule definition
     * @param {object} scope current input scope
     * @param {object} el current html element
     * @param {array} attr attributes of the html element
     * @param {array} ctrls ctrls[0] = FFFormController ctrls[1]=ngModel
     */
    ff.logicRules.ifFieldIsPrefilled = function (rule, scope, el, attr, ctrls) {
        'use strict';
        var ffFormController = ctrls[0];
        var contextualData = ffFormController.getContextualData();
        var model = ctrls[1];
        return function (scope, fieldValue) {
            if (_.isUndefined(contextualData["mfProfileProperties"])) {
                return false;
            } else {
                var searchStep = ffFormController.currentStep;
                for (searchStep; searchStep >= 0; searchStep--) {
                    var searchedInput = _.find(ffFormController.currentForm.steps[searchStep].inputs, function (input) {
                        if (input.name === rule.fieldName) {
                            return true;
                        }
                    });
                    var currentInput = _.find(ffFormController.currentForm.steps[searchStep].inputs, function (input) {
                        if (input.name === model.$name) {
                            return true;
                        }
                    });
                    // If current input should be hidden upon prefill then return false
                    if (!_.isEmpty(currentInput)) {
                        if (!_.isUndefined(currentInput.prefills) && !_.isUndefined(currentInput.prefills['mfff-prefill'])) {
                            var key = currentInput.prefills['mfff-prefill'].dataKey;

                            //Since we store object as string we need to make it an object again
                            if (key != undefined && key !== null && key !== '' && key.constructor !== Object) {
                                var dataKey = JSON.parse(key);
                                if(_.has(contextualData["mfProfileProperties"], dataKey.itemId) && currentInput.prefills['mfff-prefill'].hideAfterPrefill=="true") {
                                    return false;
                                }
                            }
                        }
                    }
                    if (!_.isEmpty(searchedInput)) {
                        if (!_.isUndefined(searchedInput.prefills) && !_.isUndefined(searchedInput.prefills['mfff-prefill'])) {
                            var key = searchedInput.prefills['mfff-prefill'].dataKey;

                            //Since we store object as string we need to make it an object again
                            if (key != undefined && key !== null && key !== '' && key.constructor !== Object) {
                                var dataKey = JSON.parse(key);
                                return _.has(contextualData["mfProfileProperties"], dataKey.itemId);
                            }
                        } else {
                            return true;
                        }
                    }

                }
            }
            return false;
        }
    };